<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOnsiteWrapUpResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfOnsiteWrapUpResult extends AbstractStructArrayBase
{
    /**
     * The OnsiteWrapUpResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\OnsiteWrapUpResult[]
     */
    public $OnsiteWrapUpResult;
    /**
     * Constructor method for ArrayOfOnsiteWrapUpResult
     * @uses ArrayOfOnsiteWrapUpResult::setOnsiteWrapUpResult()
     * @param \CustomerManagement\StructType\OnsiteWrapUpResult[] $onsiteWrapUpResult
     */
    public function __construct(array $onsiteWrapUpResult = array())
    {
        $this
            ->setOnsiteWrapUpResult($onsiteWrapUpResult);
    }
    /**
     * Get OnsiteWrapUpResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\OnsiteWrapUpResult[]|null
     */
    public function getOnsiteWrapUpResult()
    {
        return isset($this->OnsiteWrapUpResult) ? $this->OnsiteWrapUpResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOnsiteWrapUpResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOnsiteWrapUpResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOnsiteWrapUpResultForArrayConstraintsFromSetOnsiteWrapUpResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOnsiteWrapUpResultOnsiteWrapUpResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfOnsiteWrapUpResultOnsiteWrapUpResultItem instanceof \CustomerManagement\StructType\OnsiteWrapUpResult) {
                $invalidValues[] = is_object($arrayOfOnsiteWrapUpResultOnsiteWrapUpResultItem) ? get_class($arrayOfOnsiteWrapUpResultOnsiteWrapUpResultItem) : sprintf('%s(%s)', gettype($arrayOfOnsiteWrapUpResultOnsiteWrapUpResultItem), var_export($arrayOfOnsiteWrapUpResultOnsiteWrapUpResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OnsiteWrapUpResult property can only contain items of type \CustomerManagement\StructType\OnsiteWrapUpResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OnsiteWrapUpResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\OnsiteWrapUpResult[] $onsiteWrapUpResult
     * @return \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult
     */
    public function setOnsiteWrapUpResult(array $onsiteWrapUpResult = array())
    {
        // validation for constraint: array
        if ('' !== ($onsiteWrapUpResultArrayErrorMessage = self::validateOnsiteWrapUpResultForArrayConstraintsFromSetOnsiteWrapUpResult($onsiteWrapUpResult))) {
            throw new \InvalidArgumentException($onsiteWrapUpResultArrayErrorMessage, __LINE__);
        }
        if (is_null($onsiteWrapUpResult) || (is_array($onsiteWrapUpResult) && empty($onsiteWrapUpResult))) {
            unset($this->OnsiteWrapUpResult);
        } else {
            $this->OnsiteWrapUpResult = $onsiteWrapUpResult;
        }
        return $this;
    }
    /**
     * Add item to OnsiteWrapUpResult value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\OnsiteWrapUpResult $item
     * @return \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult
     */
    public function addToOnsiteWrapUpResult(\CustomerManagement\StructType\OnsiteWrapUpResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\OnsiteWrapUpResult) {
            throw new \InvalidArgumentException(sprintf('The OnsiteWrapUpResult property can only contain items of type \CustomerManagement\StructType\OnsiteWrapUpResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OnsiteWrapUpResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\OnsiteWrapUpResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\OnsiteWrapUpResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\OnsiteWrapUpResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\OnsiteWrapUpResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\OnsiteWrapUpResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OnsiteWrapUpResult
     */
    public function getAttributeName()
    {
        return 'OnsiteWrapUpResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfOnsiteWrapUpResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
